Attribute VB_Name = "vt100"
'*********************************************************************************************
'                                    Nemesis Telnet Client 32 Bits
'                                       V 3.3 (BUILD 3XY)
'
' Copyright (c) 2000-2002 Jose Antonio Coret Barneto
'
'   Nemesis Telnet Client 32 Bits - The Free Telnet Client, a part of the Nemesis Project
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
'
'    Redistributions of source code with or without modifications must retain the
'    above copyright notice, this list of conditions and the following disclaimer.
'
'--------------------------------------------------------------------------------------------
'IMPORTANT NOTICE:
'
'This is an unofficial translation of the GNU General Public License
'into Spanish. It was not published by the Free Software
'Foundation, and does not legally state the distribution terms for
'software that uses the GNU GPL--only the original English text of
'the GNU GPL does that. However, we hope that this translation will
'help Spanish speakers understand the GNU GPL better.
'--------------------------------------------------------------------------------------------
'
'   Este programa es software libre. Puede redistribuirlo y/o modificarlo
'   bajo los trminos de la Licencia Pblica General de GNU segn es
'   publicada por la Free Software Foundation, bien de la versin 2 de
'   dicha Licencia o bien de cualquier versin posterior.
'
'   Este programa se distribuye con la esperanza de que sea til, pero SIN
'   NINGUNA GARANTA, incluso sin la garanta MERCANTIL implcita o sin
'   garantizar la CONVENIENCIA PARA UN PROPSITO PARTICULAR. Vase la
'   Licencia Pblica General de GNU para ms detalles.
'
'   Debera haber recibido una copia de la Licencia Pblica General junto
'   con este programa. Si no ha sido as, escriba a la Free Software
'   Foundation, Inc., en 675 Mass Ave, Cambridge, MA 02139, EEUU.
'   Aada tambin informacin sobre cmo contactar con usted mediante
'   correo electrnico y postal.
'
'*********************************************************************************************
'
'PREVIOUS AUTHOR COPYRIGHT :
'
'******************************************************************************
' Parts of this code written by Ian Storrs.
' Latest updates stored at http://storrs.home.ml.org/video/telnet.zip
' Please report any bugs or suggested improvements to
' storrs@bellsouth.net
'
' Code released to public domain as is with warranty or any liabilty for
' any consequences direct or indirect of any kind whatsover.
' Use at your own risk !!!
'******************************************************************************

Option Explicit
Option Base 1

Global bConectado As Boolean
'Windows RECT structure
Private Type Rect
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type



Private Declare Function ScrollWindow Lib "user32" (ByVal hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As Rect, lpClipRect As Rect) As Long
Private Declare Function ScrollDC Lib "user32" (ByVal hdc As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As Rect, lprcClip As Rect, ByVal hRgnUpdate As Long, lprcUpdate As Rect) As Long
Public Declare Function PatBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nwidth As Long, ByVal nheight As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function PaintRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long

Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal NewColor As Long) As Long
Private Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long


'=================== Ternary raster operations ============
Private Const PATCOPY = &HF00021         ' (DWORD) dest = pattern
Private Const PATPAINT = &HFB0A09        ' (DWORD) dest = DPSnoo
Private Const PATINVERT = &H5A0049       ' (DWORD) dest = pattern XOR dest
Private Const DSTINVERT = &H550009       ' (DWORD) dest = (NOT dest)
Private Const BLACKNESS = &H42&          ' (DWORD) dest = BLACK
Private Const WHITENESS = &HFF0062       ' (DWORD) dest = WHITE
Private Const TRANSPARENT = 1
Private Const OPAQUE = 2

Private Const WordWrap = True
Private Const ResetToBlack = True

Private Const TabsPerPage = 20
Public Const LinesPerPage = 25
Public Const CharsPerLine = 80
Private Const LastTab = 20

Private Const LastLine = LinesPerPage
Private Const LastChar = CharsPerLine


Private ScrImage(LinesPerPage)     As String * CharsPerLine
Private ForeAttr(LinesPerPage)     As String * CharsPerLine
Private BackAttr(LinesPerPage)     As String * CharsPerLine

Private Norm_Attr                 As String * CharsPerLine
Private Blank_Line                As String * CharsPerLine

'
'   Used in API calls
'
Private TermTextColor             As Long
Private TermBkColor               As Long
Private lprcScroll                As Rect
Private lprcClip                  As Rect
Private hRgnUpdate                As Integer
Private lprcUpdate                As Rect

'
'   Flag to indicate that we're ready to run
'
Private FlagInitDone    As Boolean

'
'   Tabs handling
'
Private tabno                      As Integer
Private tab_table(TabsPerPage)     As Integer

Private VT52Mode        As Boolean
Private ForeAttribute   As String * 1 ' Current screen attibute (for any char output)
Private BackAttribute   As String * 1 ' Current screen attibute (for any char output)
Private CurX            As Integer    ' Actual current X position
Private CurY            As Integer    ' Actual current Y position
Private SavecurX        As Integer    ' Used to save current X position if requested by server
Private SavecurY        As Integer    ' Used to save current Y position if requested by server
Private SaveForeAttr    As String     ' Used to save current attribute
Private SaveBackAttr    As String
Private InEscape        As Boolean    ' Processing an escape sequence
Private EscString       As String     ' String so far

Private charheight      As Single     ' Height font metric
Private charWidth       As Single     ' Width font metric

Private CurState        As Boolean    ' Caret state
Private ret             As Long       ' Don't care return value holder
Private host            As Winsock
Private Display         As Form


Public Function term_process_char(CH As Byte)


    If (InEscape) Then

        Select Case CH

            Case 24, 26                            ' Cancel Escape
                InEscape = False

            Case vbKeyEscape                       ' Overlapping Escapes
                If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & EscString & " - Throwing away this sequence !"
                EscString = ""                     ' Throw previous away

            Case Else
                Call term_escapeProcess(CH)

        End Select

    Else

        Select Case CH

        Case 0, 127                             ' Null

        Case 2 To 6                             ' ETX,EOT,ENQ

        Case 7                                  ' BELL

            Beep

        Case vbKeyBack                          ' Backspace

          CurX = CurX - 1
          term_validatecurX

        Case vbKeyTab
            Dim tX As Integer
            For tX = 1 To LastTab
              If CurX < tab_table(tX) Then
                Exit For
              End If
            Next tX
            CurX = tab_table(tX)

        Case 10, 11, 12                         ' LF, VT, FF
            If (CurY = LastLine) Then           '   if line left on scrn
                Call term_scroll_up             '   ..  scroll upwards
            Else
                CurY = CurY + 1                 '   goto next line
            End If


        Case vbKeyReturn                        ' CR

            CurX = 1

        Case 14, 15                            ' Select Char Set

        Case 17, 19                            ' Xon/XOff

        Case 24, 26                            ' Cancel Escape
            InEscape = False

        Case vbKeyEscape

            InEscape = True
            EscString = ""

        Case Else
                term_write CH

        End Select

    End If
End Function
Public Sub term_CaretControl(TurnOff As Boolean)
Static SaveState As Boolean

    If TurnOff = True Then
        SaveState = CurState
        term_Carethide
    Else
        If SaveState = True Then
            term_Caretshow
        End If
    End If

End Sub
Public Sub term_Carethide()

    If CurState = True Then
        If Display.WindowState <> vbMinimized Then
            ret = PatBlt(Display.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, charWidth, charheight, DSTINVERT)
        End If
        CurState = False
    End If
End Sub

Public Sub term_Caretshow()

    '------------------------------------------------------------------------
    '   term_CaretShow
    '
    '   display the inverted block cursor on the screen.
    '   currently uses PatBlt.
    '------------------------------------------------------------------------

    If Display.WindowState <> vbMinimized Then
       ret = PatBlt(Display.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, charWidth, charheight, DSTINVERT)
    End If

    CurState = True

End Sub
Public Sub term_DriveCursor()
    If CurState = False Then
        Call term_Caretshow
    Else
        Call term_Carethide
    End If
End Sub
Public Sub term_eraseBOL()
'------------------------------------------------------------------------
'   term_eraseBOL
'   erase from beginning of current line
'------------------------------------------------------------------------

    If Display.WindowState <> vbMinimized Then
        ret = TextOut(Display.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine)
    End If

    Mid$(ScrImage(CurY), 1, CurX) = Space$(CurX + 1)

    Mid$(ForeAttr(CurY), 1, CurX) = String$(CurX + 1, Chr$(0))
    Mid$(BackAttr(CurY), 1, CurX) = String$(CurX + 1, Chr$(0))
End Sub

Public Sub term_eraseBOS()
'------------------------------------------------------------------------
'   term_eraseBOS
'   erase all lines from beginning of screen to and including current
'------------------------------------------------------------------------
    Dim Y As Integer

    'Erase the current line first
    Call term_eraseBOL

    'Erase everything up to current line
    If (CurY > 0) Then
        If Display.WindowState <> vbMinimized Then
            ret = TextOut(Display.hdc, 0, 0, Space$(CharsPerLine * (CurY - 1) + CurX - 1), CharsPerLine * CurY + CurX)
        End If

        ' reset screen buffer contents
        For Y = 1 To CurY
           ScrImage(Y) = Blank_Line
           ForeAttr(Y) = Norm_Attr
           BackAttr(Y) = Norm_Attr
        Next Y
    End If
End Sub

Public Sub term_eraseBUFFER()
    Dim i As Integer
    For i = 1 To LinesPerPage
        ScrImage(i) = Blank_Line
        ForeAttr(i) = Norm_Attr
        BackAttr(i) = Norm_Attr
    Next i
End Sub

Private Sub term_eraseEOL()
'
'   Erase to End of Line
'
    If Display.WindowState <> vbMinimized Then
        ret = TextOut(Display.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, Space$(CharsPerLine - CurX), CharsPerLine - CurX)
    End If

    'Update screen buffer
    Mid$(ScrImage(CurY), CurX, CharsPerLine - CurX) = Space$(CharsPerLine - CurX)
    Mid$(ForeAttr(CurY), CurX, CharsPerLine - CurX) = String$(CharsPerLine - CurX, Chr$(0))
    Mid$(BackAttr(CurY), CurX, CharsPerLine - CurX) = String$(CharsPerLine - CurX, Chr$(0))

End Sub

Private Sub term_eraseEOS()
'
'   Erase to end of screen
'
    Dim Y As Integer

    Call term_eraseEOL
    If (CurY <> LastLine) Then

        If Display.WindowState <> vbMinimized Then
            ret = TextOut(Display.hdc, 0, CurY * charheight, Space$((LastLine - CurY) * CharsPerLine), (LastLine - CurY) * CharsPerLine)
        End If

        For Y = CurY + 2 To LinesPerPage
            ScrImage(Y) = Blank_Line
            ForeAttr(Y) = Norm_Attr
            BackAttr(Y) = Norm_Attr
        Next Y

     End If
End Sub

Private Sub term_eraseLINE()

'   Erase Line

    If Display.WindowState <> vbMinimized Then
        ret = TextOut(Display.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine)
    End If

    ScrImage(CurY + 1) = Blank_Line
    ForeAttr(CurY + 1) = Norm_Attr
    BackAttr(CurY + 1) = Norm_Attr

End Sub

Private Sub term_eraseSCREEN()


    term_eraseBUFFER

    'Do they want to repaint using the latest background color ?
    If Not ResetToBlack Then
        Display.BackColor = GetBkColor(Display.hdc)
        Display.ForeColor = GetTextColor(Display.hdc)
    Else
        Display.ForeColor = QBColor(0)
        Display.ForeColor = QBColor(15)
    End If
    Display.Cls
    CurX = 1
    CurY = 1

End Sub

Private Function term_escapeParseArg(S As String) As String
'
'   PopArg takes the next argument (digits up to a ) and
'   returns it.  It also removes the arg and the  from
'   the input string "s"

    Dim i As Integer

    i = InStr(S, "")
    If i = 0 Then
        term_escapeParseArg = S
        S = ""
    Else
        term_escapeParseArg = Left$(S, i - 1)
        S = Mid$(S, i + 1)
    End If

End Function

Private Sub term_escapeProcess(CH As Byte)
    If VT52Mode = True Then
        term_VT52_Process CH
    Else
        term_VT100_process CH
    End If
End Sub

Public Sub term_init(Optional MyDisplay As Form, Optional MyHost As Winsock, Optional modo As String)

    'Note : The font must be a fixed font, not proportional
    'Note : For ANSI graphics you must use the TERMINAL font or equivalent

If modo = "" Then
    Set Display = Nothing
    Set Display = MyDisplay
    Set host = Nothing
    Set host = MyHost
End If

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Get the pixel metrics of the current font"
    
    If gbSubrayado = False Then
        Display.FontUnderline = False
    Else
        Display.FontUnderline = True
    End If
    
    If gbItalica = False Then
        Display.FontItalic = False
    Else
        Display.FontItalic = True
    End If
    
    If gbBold = False Then
        Display.FontBold = False
    Else
        Display.FontBold = True
    End If

    If gsFuente <> "" Then
       Display.FontName = gsFuente
    End If
    
    Display.ScaleMode = 3
    charheight = Display.TextHeight("M")
    charWidth = Display.TextWidth("M")
    
    On Error Resume Next
    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set up the vt100 screen using character M to get width of characters "
    Display.ScaleMode = 1
    Display.Height = (Display.Height - Display.ScaleHeight) + LinesPerPage * Display.TextHeight("M")
    Display.Height = Display.Height + Display.stbStatusBar.Height
    Display.Width = (Display.Width - Display.ScaleWidth) + CharsPerLine * Display.TextWidth("M")
    

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set the user scale of the display"
    Display.ScaleMode = 0
    Display.ScaleWidth = LinesPerPage
    Display.ScaleWidth = CharsPerLine
    Display.Scale (0, 0)-(LastChar, LastLine)
    
    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set up the scoll region and clip region structures for API calls"
    lprcScroll.Top = 0
    lprcScroll.Left = 0
    lprcScroll.Right = CharsPerLine * charWidth
    lprcScroll.Bottom = LinesPerPage * charheight
    lprcClip = lprcScroll
    hRgnUpdate = 0

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Initialize module level flags and variables"
    InEscape = False
    CurState = False
    ForeAttribute = Chr$(0)
    BackAttribute = Chr$(0)
    CurX = 1
    CurY = 1

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set the default foreground and background colors" '- use API so that TextOut works !"
    ret = SetBkMode(Display.hdc, OPAQUE)
    
    If gsColorFuente = "" Then
        Display.ForeColor = QBColor(7)
        ret = SetTextColor(Display.hdc, QBColor(7))
    Else
        Display.ForeColor = QBColor(Val(gsColorFuente))
        ret = SetTextColor(Display.hdc, QBColor(Val(gsColorFuente)))
    End If
    
    If gsColorFondo = "" Then
        Display.BackColor = QBColor(0)
        ret = SetBkColor(Display.hdc, QBColor(0))
    Else
        Display.ForeColor = QBColor(Val(gsColorFuente))
        ret = SetBkColor(Display.hdc, QBColor(Val(gsColorFuente)))
    End If
    
    TermTextColor = GetTextColor(Display.hdc)
    TermBkColor = GetBkColor(Display.hdc)
    term_eraseBUFFER
    term_resetTabs

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Initialize repaint buffers to speed up program at runtime"
    VT52Mode = False
    Norm_Attr = String$(CharsPerLine, Chr$(0))
    Blank_Line = Space$(CharsPerLine)



    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Do the cursor thing"
    term_Caretshow
    Display.cursor_timer.Enabled = True

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set a flag to avoid unnecessary repaints"
    FlagInitDone = True

End Sub
Private Function term_FindChange(InArray As String, ByVal CurrentValue As String, ByteLen As Integer) As Integer

' This subroutine attempts to find the next place on the Current Line where an attribute change occurs
' I used to have a 16 bit C DLL doing this for the VB3 version, but hope that using a byte array search will
' help in VB5 native code.


'Dim RetValue As Integer
Dim CurrentByte As Byte
Dim InByte() As Byte
Dim RetValue As Integer

CurrentByte = Asc(CurrentValue)
InByte = InArray
'
For RetValue = 0 To ByteLen Step 2
    If InByte(RetValue) <> CurrentByte Then
        Exit For
    End If
Next

term_FindChange = RetValue \ 2

' First Attempt at this used sting functions as follows :
' I think the byte array is faster, but you can try for yourself !

'Dim RetValue As Integer
'For RetValue = 1 To ByteLen
'    If Mid$(InArray, RetValue, 1) <> CurrentValue Then
'        Exit For
'    End If
'Next
'term_FindChange = RetValue - 1

End Function
Public Sub term_redrawscreen()

    Dim oldcur          As Boolean
    Dim oldattrforw     As String * 1
    Dim oldattrback     As String * 1
    Dim NewAttr         As String
    Dim Y               As Integer
    Dim X1              As Integer
    Dim X2              As Integer
    Dim AttrChange      As Integer
    Dim ForeAttrChange  As Integer
    Dim BackAttrChange  As Integer
    Dim tAttrFore       As String * CharsPerLine
    Dim tAttrBack       As String * CharsPerLine
    Dim tLine           As String * CharsPerLine


    If FlagInitDone = False Or Display.WindowState = vbMinimized Then
        'Don't do this if the program is opening or the window is
        'minimized !
        Exit Sub
    End If

    'Save the current caret state and attribute
    'Change the attribute to "0" (undefined) for the purpose of the search
    oldcur = CurState
    oldattrforw = ForeAttribute
    oldattrback = BackAttribute


    term_redraw_attribute Chr$(0)

    If Not Display.Receiving Then
        'If not receiving data, hide the caret
        Call term_Carethide
    End If


    For Y = 1 To LinesPerPage

        tAttrFore = ForeAttr(Y)
        tAttrBack = BackAttr(Y)
        tLine = ScrImage(Y)
        If (tAttrFore = Norm_Attr) And (tAttrBack = Norm_Attr) Then
            'Normal Lines can be repainted directly
            ret = TextOut(Display.hdc, 0, (Y - 1) * charheight, tLine, CharsPerLine)
        Else
            'Complex lines must have attribute changes found using the
            'function Term_FindChange.
            X1 = 1                          'Start the scan on the complete line
            X2 = CharsPerLine               'Don't go beyond the end of the line !
             Do While (X2 > 0)
             
                'Find the next change in fore and back attributes on this line
                'Use the lesser of the two changes
                ForeAttrChange = term_FindChange(Mid(tAttrFore, X1, X2), ForeAttribute, X2)
                BackAttrChange = term_FindChange(Mid(tAttrBack, X1, X2), BackAttribute, X2)
                If ForeAttrChange < BackAttrChange Then
                    AttrChange = ForeAttrChange
                Else
                    AttrChange = BackAttrChange
                End If

                'Redraw the subsection of this line with the current attributes
                ret = TextOut(Display.hdc, (X1 - 1) * charWidth, (Y - 1) * charheight, Mid$(tLine, X1, AttrChange), AttrChange)

                'Now change to the new attributes for the remainder of this line
                X2 = X2 - AttrChange
                If X2 > 0 Then
                    X1 = X1 + AttrChange
                    If ForeAttrChange < BackAttrChange Then
                        'Only update fore_attribute
                        NewAttr = Mid$(tAttrFore, X1, 1)
                        term_redraw_attribute NewAttr
                    ElseIf ForeAttrChange > BackAttrChange Then
                        'Only update back_attribute
                        NewAttr = Mid$(tAttrBack, X1, 1)
                        term_redraw_attribute NewAttr
                    Else
                        'Update both fore_attribute and back_attribute
                        NewAttr = Mid$(tAttrFore, X1, 1)
                        term_redraw_attribute NewAttr
                        NewAttr = Mid$(tAttrBack, X1, 1)
                        term_redraw_attribute NewAttr
                    End If
                End If
            Loop
        End If
    Next Y

    'Restore the previously saved caret state and attribute
    term_redraw_attribute oldattrforw
    term_redraw_attribute oldattrback
    ForeAttribute = oldattrforw
    BackAttribute = oldattrback
    If Not Display.Receiving Then
        If oldcur = True Then
            Call term_Caretshow
        End If
    End If

End Sub

Private Sub term_scroll_up()

    Dim i As Integer
    Dim S As Integer

    If Display.WindowState <> vbMinimized Then
         ret = ScrollDC(Display.hdc, 0, -charheight, lprcScroll, lprcClip, hRgnUpdate, lprcUpdate)
         ret = TextOut(Display.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine)
    End If

    'Update the redisplay buffer (only update the scrollable region)
    'Might consider making this a circular array so only one line
    'needs to be written per scroll, rather than relinking the array
    S = (lprcScroll.Top \ charheight + 1)
    For i = S To LastLine - 1
        ScrImage(i) = ScrImage(i + 1)
        ForeAttr(i) = ForeAttr(i + 1)
        BackAttr(i) = BackAttr(i + 1)
    Next i
    ScrImage(LinesPerPage) = Blank_Line
    ForeAttr(LinesPerPage) = Norm_Attr
    BackAttr(LinesPerPage) = Norm_Attr


End Sub

Private Sub term_setattr(CH As String)

Static LastTextColor As Long
Static LastBackColor As Long
Static BrightOn      As Integer
Static BlinkOn       As Boolean
Static UnderOn       As Boolean
Dim Attributes       As Integer


    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & CurY & CurX
    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set Attribute " & Asc(CH)

    Attributes = Asc(CH)

    Select Case Attributes

            Case 0  '   Normal

                Display.FontUnderline = False
                Display.FontItalic = False
                Display.FontBold = False
                BrightOn = 0
                BlinkOn = False
                UnderOn = False

                'Must also reset colors to default
                ret = SetTextColor(Display.hdc, QBColor(7))
                ret = SetBkColor(Display.hdc, QBColor(0))
                ForeAttribute = Chr$(0)
                BackAttribute = Chr$(0)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Normal"

            Case 1  '   Bold

                BrightOn = 8
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Bright On"

            Case 2  '   Half  - Not Supported
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Not Supported"
            Case 5 To 6  '   Blinking
                 Display.FontItalic = True
                 BlinkOn = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blinking On"

            Case 4  '   Underscore
                Display.FontUnderline = True
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Underline On"

            Case 7  '   Reverse Video
                ret = SetTextColor(Display.hdc, TermBkColor)
                ret = SetBkColor(Display.hdc, TermTextColor)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Reversed On"

            Case 8  '   Cancel (Invisible)
                'Save current actual colors
                LastTextColor = GetTextColor(Display.hdc)
                LastBackColor = GetBkColor(Display.hdc)

                'Set text and back colors the same
                ret = SetTextColor(Display.hdc, LastBackColor)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Invisible"

            Case 21, 22

                BrightOn = 0
                Display.FontBold = False
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Bright off"

            Case 24

                Display.FontUnderline = False
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Underline Off"

            Case 25
                 BlinkOn = False
                 Display.FontItalic = False
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blinking Off"

            Case 27
                'Reset text and back colors the same
                ret = SetTextColor(Display.hdc, LastTextColor)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Invisible Off"


            '===============================================================

            Case 30 '   Black Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 0))
                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Text"

            Case 31 '   Red Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 4))
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Text"
                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 32 '   Green Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 2))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Text"
                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 33 '   Brown - Use Yellow Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 6))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Text"

                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 34 '   Blue Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 1))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Text"

                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 35 '   Magenta Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 5))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Text"

                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 36 '   Cyan Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 3))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Text"

                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            Case 37 '   White Foreground
                ret = SetTextColor(Display.hdc, QBColor(BrightOn + 7))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Text"

                If BrightOn = 8 Then
                    Attributes = Attributes + 30
                End If
                If UnderOn = True Then
                    Attributes = Attributes + 60
                End If
                ForeAttribute = Chr$(Attributes)

            '===============================================================

            Case 40 '   Black Background
                ret = SetBkColor(Display.hdc, QBColor(0))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 41 '   Red Background
                ret = SetBkColor(Display.hdc, QBColor(4))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 42 '   Green Background
                ret = SetBkColor(Display.hdc, QBColor(2))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 43 '   Yellow Background
                ret = SetBkColor(Display.hdc, QBColor(6))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 44 '   Blue Background
                ret = SetBkColor(Display.hdc, QBColor(1))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 45 '   Magenta Background
               ret = SetBkColor(Display.hdc, QBColor(5))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 46 '   Cyan Background
                ret = SetBkColor(Display.hdc, QBColor(3))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case 47 '   White Background
                ret = SetBkColor(Display.hdc, QBColor(7))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Back"
                If BlinkOn = True Then
                    Attributes = Attributes + 30
                End If
                BackAttribute = Chr$(Attributes)

            Case Else
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "What???" & Asc(CH)
                Exit Sub
    End Select



 End Sub

Private Sub term_redraw_attribute(Attributes As String)

Static LastTextColor As Long
Static LastBackColor As Long


    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & CurY & CurX
    'frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set Attribute " & Asc(CH)


    Select Case Asc(Attributes)

            Case 0  '   Normal

                Display.FontUnderline = False
                Display.FontItalic = False
                Display.FontBold = False

                'Must also reset colors to default
                ret = SetTextColor(Display.hdc, QBColor(7))
                ret = SetBkColor(Display.hdc, QBColor(0))
                ForeAttribute = Chr$(0)
                BackAttribute = Chr$(0)

                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Normal"

            Case 1  '   Bold

                'Do Nothing

            Case 2  '   Half  - Not Supported

                'Do Nothing

            Case 5  '   Blinking
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blinking On"

            Case 4
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Underscore"
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Display.FontUnderline = True"
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Underline On"

            Case 7
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Reverse Video"
                ret = SetTextColor(Display.hdc, TermBkColor)
                ret = SetBkColor(Display.hdc, TermTextColor)
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Reversed On"

            Case 8
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cancel (Invisible)"
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Save current actual colors"
                LastTextColor = GetTextColor(Display.hdc)
                LastBackColor = GetBkColor(Display.hdc)

                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set text and back colors the same"
                ret = SetTextColor(Display.hdc, LastBackColor)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Invisible"

            Case 21, 22 'Unbold

                'Do Nothing

            Case 24

                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Underline Off"

            Case 25

                 Display.FontItalic = False
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blinking Off"

            Case 27
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Reset text and back colors the same"
                ret = SetTextColor(Display.hdc, LastTextColor)
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Invisible Off"


            '===============================================================

            Case 30 '   Black Foreground
                ret = SetTextColor(Display.hdc, QBColor(0))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Text"

            Case 31 '   Red Foreground
                ret = SetTextColor(Display.hdc, QBColor(4))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Text"

            Case 32 '   Green Foreground
                ret = SetTextColor(Display.hdc, QBColor(2))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Text"

            Case 33 '   Brown - Use Yellow Foreground
                ret = SetTextColor(Display.hdc, QBColor(6))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Text"

            Case 34 '   Blue Foreground
                ret = SetTextColor(Display.hdc, QBColor(1))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Text"

            Case 35 '   Magenta Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(5))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Text"

            Case 36 '   Cyan Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(3))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Text"

            Case 37 '   White Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(7))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Text"



            '===============================================================

            Case 40 '   Black Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(0))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Back"

            Case 41 '   Red Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(4))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Back"

            Case 42 '   Green Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(2))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Back"

            Case 43 '   Yellow Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(6))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Back"

            Case 44 '   Blue Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(1))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Back"

            Case 45 '   Magenta Background
               Display.FontItalic = False
               ret = SetBkColor(Display.hdc, QBColor(5))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Back"

            Case 46 '   Cyan Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(3))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Back"

            Case 47 '   White Background
                Display.FontItalic = False
                ret = SetBkColor(Display.hdc, QBColor(7))
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Back"

            '===============================================================

            Case 60 '   Black Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(8))
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Text"

            Case 61 '   Red Foreground
                ret = SetTextColor(Display.hdc, QBColor(12))
                Display.FontUnderline = False
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Text"

            Case 62 '   Green Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(10))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Text"

            Case 63 '   Brown - Use Yellow Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(14))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Text"

            Case 64 '   Blue Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(9))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Text"

            Case 65 '   Magenta Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(13))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Text"

            Case 66 '   Cyan Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(11))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Text"

            Case 67 '   White Foreground
                Display.FontUnderline = False
                ret = SetTextColor(Display.hdc, QBColor(15))
                ForeAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Text"


            '===============================================================

            Case 70 '   Black Background
                ret = SetBkColor(Display.hdc, QBColor(0))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Back"

            Case 71 '   Red Background
                ret = SetBkColor(Display.hdc, QBColor(12))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Back"

            Case 72 '   Green Background
                ret = SetBkColor(Display.hdc, QBColor(10))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Back"

            Case 73 '   Yellow Background
                ret = SetBkColor(Display.hdc, QBColor(14))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Back"

            Case 74 '   Blue Background
                ret = SetBkColor(Display.hdc, QBColor(9))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Back"

            Case 75 '   Magenta Background
                 ret = SetBkColor(Display.hdc, QBColor(13))
                 Display.FontItalic = True
                 BackAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Back"

            Case 76 '   Cyan Background
                 ret = SetBkColor(Display.hdc, QBColor(11))
                 Display.FontItalic = True
                 BackAttribute = Attributes
               frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Back"

            Case 77 '   White Background
                ret = SetBkColor(Display.hdc, QBColor(15))
                Display.FontItalic = True
                BackAttribute = Attributes
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Back"

            '===============================================================

            Case 90 '   Black Foreground
                ret = SetTextColor(Display.hdc, QBColor(0))
                Display.FontUnderline = True
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Text"

            Case 91 '   Red Foreground
                ret = SetTextColor(Display.hdc, QBColor(4))
                 Display.FontUnderline = True
                ForeAttribute = Attributes
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Text"

            Case 92 '   Green Foreground
                ret = SetTextColor(Display.hdc, QBColor(2))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Text"
                 Display.FontUnderline = True
                ForeAttribute = Attributes

            Case 93 '   Brown - Use Yellow Foreground
                ret = SetTextColor(Display.hdc, QBColor(6))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Text"
                 Display.FontUnderline = True
                ForeAttribute = Attributes

            Case 94 '   Blue Foreground
                ret = SetTextColor(Display.hdc, QBColor(1))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Text"
                 Display.FontUnderline = True
                ForeAttribute = Attributes

            Case 95 '   Magenta Foreground
                ret = SetTextColor(Display.hdc, QBColor(5))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Text"
                 Display.FontUnderline = True
                ForeAttribute = Attributes

            Case 96 '   Cyan Foreground
                ret = SetTextColor(Display.hdc, QBColor(3))
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Text"
                 Display.FontUnderline = True
                ForeAttribute = Attributes

            Case 97 '   White Foreground
                ret = SetTextColor(Display.hdc, QBColor(7))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Text"
                ForeAttribute = Attributes


            '===============================================================

            Case 120 '   Black Foreground
                ret = SetTextColor(Display.hdc, QBColor(8))
                 Display.FontUnderline = True
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Black Text"
                ForeAttribute = Attributes

            Case 121 '   Red Foreground
                ret = SetTextColor(Display.hdc, QBColor(12))
                 Display.FontUnderline = True
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Red Text"
                ForeAttribute = Attributes

            Case 122 '   Green Foreground
                ret = SetTextColor(Display.hdc, QBColor(10))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Green Text"
                ForeAttribute = Attributes

            Case 123 '   Brown - Use Yellow Foreground
                ret = SetTextColor(Display.hdc, QBColor(14))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Yellow Text"
                ForeAttribute = Attributes

            Case 124 '   Blue Foreground
                ret = SetTextColor(Display.hdc, QBColor(9))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Blue Text"
                ForeAttribute = Attributes

            Case 125 '   Magenta Foreground
                ret = SetTextColor(Display.hdc, QBColor(13))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Magenta Text"
                ForeAttribute = Attributes

            Case 126 '   Cyan Foreground
                ret = SetTextColor(Display.hdc, QBColor(11))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cyan Text"
                ForeAttribute = Attributes

            Case 127 '   White Foreground
                ret = SetTextColor(Display.hdc, QBColor(15))
                 Display.FontUnderline = True
                 frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "White Text"
                ForeAttribute = Attributes

            Case Else
                'frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "What???" & Asc(CH)
                Exit Sub
    End Select



End Sub
Private Sub term_validatecurX()
   If (CurX < 1) Then
        CurX = 1
   ElseIf CurX > LastChar Then
    If WordWrap = True Then
        CurX = 1
        If (CurY = LastLine) Then          '   if line left on scrn
           Call term_scroll_up             '   ..  scroll upwards
        Else
           CurY = CurY + 1                 '   goto next line
        End If
    Else
        CurX = LastChar
    End If
   End If
End Sub

Private Sub term_validatecurY()
   If (CurY < 1) Then
        CurY = 1
   ElseIf CurY > LastLine Then
        CurY = LastLine
   End If
End Sub

Private Sub term_write(CH As Byte)
' This subroutine has 3 purposes
' 1. Write a character to the screen if the form is not minimized
' 2. Save that character and it's attribute in the repaint buffer
' 3. Move the cursor over one character, and if necessary do wordwrapping/scroll

    If Display.WindowState <> vbMinimized Then
        ret = TextOut(Display.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, Chr$(CH), 1)
    End If

    Mid$(ScrImage(CurY), (CurX), 1) = Chr$(CH)      ' save this character
    Mid$(ForeAttr(CurY), (CurX), 1) = ForeAttribute ' and its attributes
    Mid$(BackAttr(CurY), (CurX), 1) = BackAttribute ' and its attributes

    If Not (CurX = LastChar) Then
        CurX = CurX + 1
    Else
        If WordWrap = True Then                          ' If Wordwrap is on then
            CurX = 1                                     ' Move to column one of next line
            If (CurY = LastLine) Then                    ' if line left on scrn
               Call term_scroll_up                       ' ..  scroll upwards
             '  If Display.Tracevt100 Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  "Executing scrolled wordwrap, line was too long"
            Else
               CurY = CurY + 1                           ' goto next line
             '  If Display.Tracevt100 Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  "Executing wordwrap, line was too long"
            End If
        Else
            'If Display.Tracevt100 Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  "Not Executing wordwrap, line is truncated"
            'No wordwrap, the next characters will be truncated
        End If
    End If

End Sub

Sub term_VT52_Process(CH As Byte)
Const Usup = "Unsupported VT52 Escape Sequence : ESC"
Dim C As String * 1
' This subroutine parses and processes a subset of VT52 mode sequences

    C = Chr$(CH)
    Select Case C

        Case "A"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & " A ==> move cursor up"


            CurY = CurY - 1
            term_validatecurY

        Case "B"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " B ==> move cursor down"

            CurY = CurY + 1
            term_validatecurY

        Case "C"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " C ==> move cursor right"

            CurX = CurX + 1
            term_validatecurX

        Case "D"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " D ==> move cursor left"

            CurX = CurX - 1
            term_validatecurX

        Case "E"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Line Feed"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "F"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Special Character set"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "G"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ASCII Character set"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "H"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Home Cursor"

            CurY = 1
            term_validatecurY

            CurX = 1
            term_validatecurX

        Case "I"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT52 Reverse line feed"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "J"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Erase to end of screen"

             Call term_eraseEOS

        Case "K"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Erase to end of screen"

            Call term_eraseEOL

        Case "W"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Print Controller On"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "X"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Print Controller Off"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "Y"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cursor Address"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "Z"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Identify"
            host.SendData Chr$(27) & "/Z"         'VT52 default response

        Case "]"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Print Screen"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "^"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Auto Print On"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "-"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Auto Print Off"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "="
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Alternate Keypad"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case ">"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Numeric Keypad"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "<"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Change to ANSI mode"
            VT52Mode = False
    End Select

    InEscape = False
    EscString = ""

End Sub

Sub term_VT100_process(CH As Byte)
Const Usup = "- Unsupported VT100 Escape Sequence !"
Dim C           As String
Dim yDiff       As Integer
Dim xDiff       As Integer
Dim i           As Integer

' This subroutine parses and processes a subset of VT100 mode sequences

    C = Chr$(CH)
    If EscString = "" Then
      frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "No start character yet"
      Select Case C
        Case "["
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " CSI (ESC[ = CSI)"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 ESC "

        Case "]"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " OSC Operating System Command"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "^"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " PM Privacy Mode"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "!"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Unknown BBS Sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "_"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " APC Application Program Command"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "n"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " LS2"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False

        Case "o"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LS3"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False

        Case "|"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LS3R"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False

        Case "}"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " LS2R"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False

        Case "~"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " LS1R"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False

        Case "#"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Escape Square"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False


        Case "7"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "save cursor"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Save cursor position"
            SavecurX = CurX
            SavecurY = CurY
            SaveForeAttr = ForeAttribute
            SaveBackAttr = BackAttribute
            
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI 7" & CurY & CurX & Asc(ForeAttribute) & Asc(BackAttribute)
            InEscape = False

        Case "8"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "restore cursor"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "restore cursor position"
            CurX = SavecurX
            CurY = SavecurY
            ForeAttribute = SaveForeAttr
            BackAttribute = SaveBackAttr
            term_setattr ForeAttribute
            term_setattr BackAttribute
            
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI 8" & CurY & CurX & Asc(ForeAttribute) & Asc(BackAttribute)
            InEscape = False

        Case "c"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "look at VSIreset()"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Hard terminal reset"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI c"
              term_init
              InEscape = False
              Exit Sub

        Case "D"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "index / cursor down"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI D"
            CurY = CurY + 1
            term_validatecurY
            InEscape = False
            Exit Sub

        Case "E"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "new line"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI E"
            CurX = 1
            CurY = CurY + 1
            term_validatecurY
            term_validatecurX
            InEscape = False
            Exit Sub

        Case "H"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "set tab"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI H"
            tab_table(tabno) = CurX
            tabno = tabno + 1
            InEscape = False
            Exit Sub

        Case "I"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "look at bp_ESC_I()"
            InEscape = False
            Exit Sub

        Case "M"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "reverse index / cursor up"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI M"
            CurY = CurY - 1
            term_validatecurY
            InEscape = False
            Exit Sub

        Case "P"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " look at VSIreset()"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Start of a Device Control Sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI P"
            InEscape = False
            Exit Sub

        Case "Z"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " send identity"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " DEC Device Attributes - respond as VT100"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 CSI Z"
            host.SendData Chr$(27) & "[?10c"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 default response"
            InEscape = False
            Exit Sub
        Case Else
              frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Invalid start of escape sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & C & Usup
            InEscape = False

            Exit Sub
      End Select
    End If

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Adding the latest character to the escape sequence buffer"
    EscString = EscString & C
    If IsCharAlpha(CH) = 0 Then
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Not a character ..."
        If Len(EscString) > 15 Then
          frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Sequence is too long. Throw it away"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & EscString & Usup & " too long :"
            InEscape = False
        End If
        If C = "!" Then
            InEscape = False
            EscString = ""
        End If
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Wait for more characters"
        Exit Sub
    End If

    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "We must be finished"
    If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & EscString

    Select Case C
        Case "@"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Insert Character"
             If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "IGNORE"


        Case "A"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " A ==> move cursor up"

            EscString = Mid$(EscString, 2)

            yDiff = Val(term_escapeParseArg(EscString))
            If yDiff = 0 Then
                yDiff = 1
            End If

            CurY = CurY - yDiff
            term_validatecurY

        Case "B"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " B ==> move cursor down"

            EscString = Mid$(EscString, 2)

            yDiff = Val(term_escapeParseArg(EscString))
            If yDiff = 0 Then
                yDiff = 1
            End If

            CurY = CurY + yDiff
            term_validatecurY

        Case "C"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " C ==> move cursor right"

            EscString = Mid$(EscString, 2)

            xDiff = Val(term_escapeParseArg(EscString))
            If xDiff = 0 Then
                xDiff = 1
            End If

            CurX = CurX + xDiff
            term_validatecurX

        Case "D"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " D ==> move cursor left"

            EscString = Mid$(EscString, 2)

            xDiff = Val(term_escapeParseArg(EscString))
            If xDiff = 0 Then
                xDiff = 1
            End If
            CurX = CurX - xDiff
            term_validatecurX

        Case "E"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Line Feed"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "F"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Special Character set"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "G"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cursor absolute position ????"

            EscString = Mid$(EscString, 2)

            CurX = Val(EscString) - 1
            term_validatecurX


        Case "H"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Goto cursor position indicated by escape sequence"

            EscString = Mid$(EscString, 2)

            CurY = Val(term_escapeParseArg(EscString)) - 1
            term_validatecurY

            CurX = Val(EscString) - 1
            term_validatecurX

        Case "I"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT52 Reverse line feed"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "J"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Erase display"

            Select Case Val(Mid$(EscString, 2))

                Case 0
                    If CurX = 1 And CurY = 1 Then
                        Call term_eraseSCREEN
                    Else
                        Call term_eraseEOS
                    End If

                Case 1
                    Call term_eraseBOS

                Case 2
                    Call term_eraseSCREEN

            End Select

        Case "K"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Erase line"
            Select Case Val(Mid$(EscString, 2))
                Case 0
                    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "erase to end of line"
                    Call term_eraseEOL
                Case 1
                    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "erase to beginning of line"
                    Call term_eraseBOL
                Case 2
                    Call term_eraseLINE
            End Select

        Case "L"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Insert Line"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "M"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Delete Line"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

            'Select Case Val(Mid$(EscString, 2))
            '    Case 0
            '        Call term_deleteLine
            '    Case Else
            '        For I = 1 To Val(Mid$(EscString, 2))
            '            Call term_deleteLine
            '        Next I
            'End Select

        Case "N"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Ansi music"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "P"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Delete current character"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "S"
            CurY = CurY + 1
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " cursor down"
            term_validatecurY

        Case "T"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " cursor up"
            CurY = CurY - 1
            term_validatecurY

        Case "U"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Clear Screen"
            term_eraseSCREEN

        Case "Y"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Delete line"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "W"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Print Controller On"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "X"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Print Controller Off"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "Z"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "BackTab"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

        Case "b"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Graphics Request"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " boxes          ESC [ 1 <Row>  <Col>  <Wide>  <High>  <Att> b"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "                ESC [ 5  3 0 b"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " save screen    ESC [ 3 b"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " restore screen ESC [ 4 b"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " IMPLEMENT LATER"

        Case "c"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " DEC Device Attributes - respond as VT100"
            host.SendData Chr$(27) & "[?10c"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 default response"


        Case "f"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Same as H"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Goto cursor position indicated by escape sequence"

            EscString = Mid$(EscString, 2)

            CurY = Val(term_escapeParseArg(EscString))
            term_validatecurY

            CurX = Val(EscString)
            term_validatecurX

        Case "g"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " reset tabs"
            term_resetTabs

        Case "h"

            EscString = Mid$(EscString, 2)
             Select Case Val(EscString)
                Case 0
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Error - ignore"
                Case 1
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Change cursor keys application"
                Case 2: VT52Mode = False
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Mode - VT102"
                Case 6
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Functions on in scroll region - don't ignore margins"
                Case 7
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Wordwrap on"
                Case 25
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Cursor on"
                Case 255
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Doorway on - cannot work with telnet"
             End Select

        Case "i"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " print though mode - ignore"

        Case "l"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set Options"
            EscString = Mid$(EscString, 2)
             Select Case Val(EscString)
                Case 0
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Error - ignore"
                Case 1
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Change cursor keys application vs Mode - VT52 or ANSI"
                Case 2: VT52Mode = True
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Mode - VT52"
                Case 6
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Functions off in scroll region - ignore margins"
                Case 7
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Wordwrap Off"
                Case 25
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Cursor Off"
                Case 255
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Doorway off - cannot work with telnet"
             End Select

        Case "m"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Change text attributes, screen colors"

            EscString = Mid$(EscString, 2)

            Do
                Call term_setattr(Chr$(Val(term_escapeParseArg(EscString))))
            Loop While EscString <> ""

        Case "n"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Status Request - often used to assess ANSI compliance"
            EscString = Mid$(EscString, 2)
            Select Case Val(EscString)
                Case 5
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Device Status"
                    host.SendData Chr$(27) & "[0n"
                    frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "OK"
                Case 6
                frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Cursor Position"
                    host.SendData Chr$(27) & "[" & CStr(CurY) & "" & CStr(CurX) & "R"
            End Select

        Case "p"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 keyboard reassignment - ignore"

        Case "q"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 lights on/off - ignore"

        Case "r"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Set scrollable region"
            EscString = Mid$(EscString, 2)

            lprcScroll.Top = (Val(term_escapeParseArg(EscString)) - 1) * charheight
            lprcClip = lprcScroll

        Case "s"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "Save cursor position"
            SavecurX = CurX
            SavecurY = CurY

            SaveForeAttr = ForeAttribute
            SaveBackAttr = BackAttribute
            
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & CurY & CurX & Asc(ForeAttribute) & Asc(BackAttribute)

        Case "u"

            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "restore cursor position"
            CurX = SavecurX
            CurY = SavecurY
            ForeAttribute = SaveForeAttr
            BackAttribute = SaveBackAttr
            term_setattr ForeAttribute
            term_setattr BackAttribute
            
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & CurY & CurX & Asc(ForeAttribute) & Asc(BackAttribute)

        Case "y"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "VT100 test - ignore"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "    Esc [ 2  8 y   Wait for poweroff."
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "    Esc [ 2  15 y  Flashing background mode.  Also puts terminal in local."

        Case "z"
            frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ANSI reset - ignore"

        Case "t"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Unknown BBS Sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "_"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Unknown BBS Sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C
            InEscape = False
            Exit Sub

        Case "!"
        frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & " Unknown BBS Sequence"
            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & C

        Case Else

            If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Usup & EscString

    End Select
    If Display.Tracevt100 Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf

    InEscape = False
    EscString = ""

End Sub

Private Sub term_resetTabs()
Dim tX As Integer
    For tX = 1 To LastTab
        tab_table(tX) = tX * 4
    Next tX
End Sub


